unit esperma;

INTERFACE

procedure go;

IMPLEMENTATION

uses main,Mode13,vector,colors,keys,MyMidas,Anima13;
const
	MAX=10;
	MAGIC=round(1.6*256);

procedure go;
var
	c,c1:Tpal;
	a,b,d,l,
	n1,n2,n3,
	x,y,z:integer;
	ani1,ani2,ani3:Pani;
	t:Pobject;
	n:LongInt;
	salir:boolean;

begin
	StartCrono;
	ClearVideo;
	SetTransferMode(COPY_CLEAR);

	if not LoadPal(c,'ESPERMA.RGB') then error('ESPERMA.RGB');
	InkAllRGB(0,255,c);

	if not LoadObject(t,'TUNEL_XL.3D') then error('TUNEL_XL.3D');
	with t^ do
		begin
			mz:=2500;
			ZclipMin:=327;ZobjectMin:=-1800;
		end;
	RemapColors(t,128,127);

	PutGouraudObject(t,TRUE);
	ClearVideo;
	t^.mz:=-2500;

	if LoadAni(ani1,'SPERMA',TEXTURE)=-1 then error('SPERMA.ANI');
	with ani1^ do
		begin
			Amx:=200;Amy:=50;Amz:=1500;
			Acaida:=70;Abalanza:=340;Aderiva:=0;
		end;
	if not LoadAniTexture(ani1,'GREY665X.RAW',c1) then error('GREY665X.RAW');

	MakeCloneAni(ani1,ani2);
	with ani2^ do
		begin
			Amx:=-200;Amz:=1250;
			Abalanza:=20;
		end;

	MakeCloneAni(ani1,ani3);
	with ani3^ do
		begin
			Amx:=0;Amy:=-100;Amz:=1750;
			Abalanza:=0;
		end;

	n1:=1;n2:=3;n3:=6;
	SetCalculs(SLOW);

	d:=StartFrame;
	a:=0;b:=0;l:=0;
	salir:=FALSE;
	repeat
		for d:=1 to SkipFrames do
			begin
				x:=16*sine[l+COSINE] div ESCALE;
				y:=8*sine[l] div ESCALE;
				z:=32*sine[l] div ESCALE;
				inc(l,6);
				if l>DEG then dec(l,DEG);

				with t^ do
					begin
						inc(mz,25);
						if mz>2900 then
							begin
								salir:=TRUE;	{}
								break;
							end;

						inc(balanza);
						if balanza>DEG then balanza:=0;
					end;

				inc(n1);
				if n1>MAX then n1:=1;
				with ani1^ do
					begin
						inc(Aderiva);
						if Aderiva=DEG then Aderiva:=0;

						if a>50 then inc(Amz,50);
					end;

				inc(n2);
				if n2>MAX then n2:=1;
				with ani2^ do
					begin
						inc(Aderiva,2);
						if Aderiva=DEG then dec(Aderiva,DEG);

						if a>100 then inc(Amz,25);
					end;

				inc(n3);
				if n3>MAX then n3:=1;        {No se mueve}
				with ani3^ do
					begin
						inc(Aderiva,3);
						if Aderiva=DEG then dec(Aderiva,DEG);

						if a>150 then dec(Amz,23);
					end;

				inc(a);
			end;
		if salir then break;

		PutGouraudLight(x,y,z);
		PutGouraudObject(t,FALSE);

		PlayAni(ani1,n1,TRUE);
		PlayAni(ani2,n2,TRUE);
		PlayAni(ani3,n3,TRUE);

		if inkey[K_ESC] then halt;

		SkipFrames:=anima;
	until StopCrono>times[main.ESPERMA1];

	{$IFDEF _DEBUG_}
	WriteLn(fich,'ESPERMA1: ',StopCrono);
	{$ENDIF}

	StartCrono;
	FillChar(WhitePal,Sizeof(WhitePal),63);
	DifumineToPalette(0,255,WhitePal);
	delay(0.5);

	SetTransferMode(COPY_BACKGROUND);
	if not LoadIMG('OVULED.IMG',BackPage,c1) then error('OVULED.IMG');
	InkAllRGB(0,255,c1);
	anima;
	anima;
	SetTransferMode(COPY_CLEAR);
	delay(3);

	Sdim[0].width:=320;Sdim[0].height:=200;
	Sdim[0].Psprite:=PvRAM2;

	SkipFrames:=StartFrame;
	n:=0;
	repeat
		for d:=1 to SkipFrames do inc(n);

		PutScaleSprite(0,n*MAGIC div 256,n,319-(n*MAGIC div 256),199-n);
		SkipFrames:=anima;

		if StopCrono>times[main.ESPERMA2] then break;
	until n>100;

	{$IFDEF _DEBUG_}
	WriteLn(fich,'ESPERMA2: ',StopCrono);
	{$ENDIF}

	FreeAniTexture(ani1);
	FreeAni(ani1);

{	dispose(ani1);
	dispose(ani2);
	dispose(ani3);}

	FreeObject(t);

	SetCalculs(FAST);
end;

end.